define(["jquery","cookie","lang","jRange"],function($,cookie,lang,jRange){
	camera={
		open:false,
		start:false,
		interval:null,
		saveDestination:"phone",
		flashlight:0,
		cameraSocket:null,
		rotateData:90,
		frontCamera:0,
		imgHeight:380,
		curent_proportion:"",//当前图片比例
		samewifi:cookie.getCookie("zapya_webshare_samewifi")=="false"?false:true,
		cid:"cid"+cookie.getCookie("cid"),
		relayIp:cookie.getCookie("relayIp"),
		relayPort:cookie.getCookie("relayPort"),
		version:cookie.getCookie("version"),
		//打开相机
		openCamera:function(){
			camera.open=true;
			camera.start=true;
			var that=this;
			$("#camera_operate_button_switch").find("img").addClass("camera_open").removeClass("camera_close");
			$("#camera_switch_bar").css("background-color","#fc4847");
			var params={open:1};
			if(camera.curent_proportion !== ""){
				params.ratio=camera.curent_proportion;
			}
			$.ajax({
				type:"post",
				url:that.samewifi?"/v1/mobiles/camera":"/relay/"+that.cid+"/v1/mobiles/camera",
				data:params,
				success:function(data, textStatus){
					if(camera.curent_proportion === ""){
						if(data.ratios !== undefined){
							camera.curent_proportion=data.ratios[0];
						    camera.resize();
							camera.setProportions(data.ratios);
						}
					}
					if(data.cameraid !== undefined){
						camera.frontCamera=data.cameraid;
					}
					camera.setCameraSocket();
				},
				error:function(XMLHttpRequest, textStatus, errorThrown){
					$("#camera_operate_button_switch").find("img").addClass("camera_close").removeClass("camera_open");
					$("#camera_switch_bar").css("background-color","#ccc");
					if(XMLHttpRequest.status === 403){
						$.fn.getProcess("show",{p_text:lang.setContent("phone_13"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},2000)});
					}	
				}
			})
		},
		//建立相机的websocket连接
		setCameraSocket:function(){
			var that=this;
			var socketIp=cookie.getCookie("socketIp");
			var socketPort=cookie.getCookie("socketPort");
			var cameraSocketUrl="";
			if (window.WebSocket) {
				if(that.samewifi){//同一wifi下
					if(socketIp !== null && socketPort !== null && socketIp !== "" && socketPort !== ""){//在device里已经获取到sockt的ip和socket
						cameraSocketUrl="ws://"+socketIp+":"+socketPort+"/v1/mobiles/camera/preview";
					    camera.cameraSocket=new WebSocket(cameraSocketUrl);
						camera.cameraSocket.onclose=function(){
							camera.open=false;
							camera.start=false;
						}
						camera.startCamera();	
					}else{
						$.ajax({
							type:"get",
							url:"/v1/mobiles/websocketserver",
							success:function(socketResult){
								cookie.setCookie("socketIp",socketResult.ip);
								cookie.setCookie("socketPort",socketResult.port);
								var cameraSocketUrl="ws://"+socketResult.ip+":"+socketResult.port+"/v1/mobiles/camera/preview";
								camera.cameraSocket=new WebSocket(cameraSocketUrl);
								camera.cameraSocket.onclose=function(){
									camera.open=false;
									camera.start=false;
								}
								camera.startCamera();
							}
						})
					}
				}else{//不同wifi下
					var socketUrl="ws://"+that.relayIp+":"+that.relayPort+"/relayws/"+that.cid+"/v1/mobiles/camera/preview";
					camera.cameraSocket=new WebSocket(socketUrl);
					camera.cameraSocket.onclose=function(){
						camera.open=false;
						camera.start=false;
					}
					camera.startCamera();
				}
			           
			}else{
			    camera.startCamera();
			    return;
			}
		},
		//关闭相机
		closeCamera:function(){
			var that=this;
			var params={open:0};
			if(camera.curent_proportion !== ""){
				params.ratio=camera.curent_proportion;
			}
			$.ajax({
				type:"post",
				url:that.samewifi?"/v1/mobiles/camera":"/relay/"+that.cid+"/v1/mobiles/camera",
				data:params,
				success:function(data, textStatus){
					camera.open=false;
				},
				error:function(){
					
				}
			})
		},
		//设置比例选择
		setProportions:function(arry){
			var parryDom=[];
			var that=this;
			$("#proportionSelectDiv ul").empty();
			$.each(arry,function(index,ption){
				var doms="<li";
				if(index == 0){
					doms+=" class='selected'>"+ption+"</li>";
				}else{
					doms+=">"+ption+"</li>";
				}
				parryDom.push(doms);
			});
			$("#proportionSelectDiv ul").append(parryDom.join(""));
			$("#proportionSelectDiv li").bind("click",function(){
				if(!$(this).hasClass("selected")){
					$("#proportionSelectDiv li.selected").removeClass("selected");
					$(this).addClass("selected");
					var selectP=$(this).html();
					camera.curent_proportion=selectP;
					$.ajax({
						type:"POST",
						url:that.samewifi?"/v1/mobiles/camera/settings/ratio":"/relay/"+that.cid+"/v1/mobiles/camera/settings/ratio",
						data:{ratio:selectP},
						success:function(){
							camera.resize();
							camera.setCameraSocket();
							$("#proportionSelectDiv").hide();
							$("#camera_config_item_proportion img").css("opacity",0.5);
						}
					})
				}
			})
		},
		//ajax方式拉取图片信息
		getCameraImg:function(){
			var that=this;
			$.ajax({
				type:"get",
				url:that.samewifi?"/v1/mobiles/camera/preview":"/relay/"+that.cid+"/v1/mobiles/camera/preview",
				cache:false,
				success:function(data){
					$("#camera_img").show();
					var byteData=data.substring(0,data.indexOf("rotate"));
					var rotate="";
					if(that.version=="Android"){
						rotate=data.substring(data.indexOf("rotate")+6,data.indexOf("direction"));
					}else{
						rotate=data.substring(data.indexOf("rotate")+6);
					}
					camera.setCameraImg(byteData,rotate);
					data=null;
				}
			})
		},
		resize:function(){
			//获取屏幕高度
			var camera_width=464;
			var camera_height=261;
			var camera_li_height=$(".camera-panel-li").height();
			if(camera_li_height>100 &&　camera_li_height < 520){
				camera_width=432;
				camera_height=243;
				$("#camera_table_new").css("margin","120px auto 0");
			}else{
				$("#camera_table_new").css("margin","135px auto 0");
			}
			$("#camera_left_bar").height(camera_height);
			$("#camera_right_bar").height(camera_height);
			$("#camera_img_container").height(camera_height).width(camera_width);
			var proportion="";
			if(camera.curent_proportion === ""){
				proportion="16:9"; 
			}else{
				proportion=camera.curent_proportion;
			}
			var het=Number(proportion.substring(proportion.indexOf(":")+1,proportion.length));
			var wth=Number(proportion.substring(0,proportion.indexOf(":")));
			var adjust_width=camera_height*wth/het;
			if(adjust_width<camera_width){
				var margin_left=(camera_width-adjust_width-30)/2;//30是下面操作栏的宽度
				$("#camera_img_new").height(camera_height).width(adjust_width).css("margin","0 0 0 "+margin_left+"px");
			}else{
				var adjust_height=camera_width*het/wth;
				var margin_top=(camera_height-adjust_height)/2;
				$("#camera_img_new").height(adjust_height).width(camera_width).css("margin",margin_top+"px 0 0 0");
			}

		},
		init:function(){
			var that=this;
			$("#camera_config_item_help").click(function(){
				$("#camera_notice").toggle();
				if($("#camera_notice").is(":hidden")){
					$(this).find("img").css("opacity",0.5);
				}else{
					$(this).find("img").css("opacity",1);
				}
			})
			$("#camera_notice_head i").click(function(){
				$("#camera_notice").hide();
				$("#camera_config_item_help").find("img").css("opacity",0.5);
			});
			//辅助线
			$("#camera_config_item_addline").click(function(){
				$("#help_lines_div").toggle();
				if($("#help_lines_div").is(":hidden")){
					$(this).find("img").css("opacity",0.5);
				}else{
					$(this).find("img").css("opacity",1);
				}
			});
			//设置比例
			$("#camera_config_item_proportion img").click(function(){
				$("#proportionSelectDiv").toggle();
				if($("#proportionSelectDiv").is(":hidden")){
					$(this).css("opacity",0.5);
				}else{
					$(this).css("opacity",1);
					//设置质量，保存位置div隐藏
					$("#qualitySelectDiv").hide();
					$("#camera_config_item_quality img").css("opacity",0.5);
					$("#save_desposition_chose_div_new").hide();
					$("#camera_config_item_saveposition").find("img").css("opacity",0.5);

				}
			});
			$("#camera_config_item_quality img").click(function(){
				$("#qualitySelectDiv").toggle();
				if($("#qualitySelectDiv").is(":hidden")){
					$(this).css("opacity",0.5);
				}else{
					$(this).css("opacity",1);
					//设置比例,保存位置div隐藏
					$("#proportionSelectDiv").hide();
					$("#camera_config_item_proportion img").css("opacity",0.5);
					$("#save_desposition_chose_div_new").hide();
					$("#camera_config_item_saveposition").find("img").css("opacity",0.5);
				}
			})
			camera.resize();
			$("#camera_operate_button_switch").bind("click",function(){
				if($(this).find("img").hasClass("camera_close")){//相机关闭状态
					camera.continueCamera();
				}else{
					camera.stopCamera();
				}
			});
			$("#camera_config_item_saveposition img").bind("click",function(){
				$("#save_desposition_chose_div_new").toggle();
				if($("#save_desposition_chose_div_new").is(":hidden")){
					$(this).find("img").css("opacity",0.5);
				}else{
					$(this).find("img").css("opacity",1);
					//设置比例，设置质量div隐藏
					$("#qualitySelectDiv").hide();
					$("#camera_config_item_quality img").css("opacity",0.5);
					$("#proportionSelectDiv").hide();
					$("#camera_config_item_proportion img").css("opacity",0.5);

				}
			});
			$("#save_desposition_chose_div_new input[type=radio]").bind("click",function(){
				camera.saveDestination=$("#save_desposition_chose_div_new input[type=radio]:checked").val();
			});
			$("#save_desposition_chose_div_new label").bind("click",function(){
				var $input=$(this).prev("input");
				$input.prop("checked", "checked");
				camera.saveDestination=$input.val();
			});
			//设置
			$("#camera_config_show_button").bind("click",function(){
				$("#camera_config_div").toggle();
				if($(this).find("i").hasClass("uk-icon-cog")){
					$(this).find("i").removeClass("uk-icon-cog").addClass("uk-icon-close");
				}else{
					$(this).find("i").removeClass("uk-icon-close").addClass("uk-icon-cog");
					$("#qualitySelectDiv").hide();
					$("#camera_config_item_quality img").css("opacity",0.5);
					$("#proportionSelectDiv").hide();
					$("#camera_config_item_proportion img").css("opacity",0.5);
					$("#save_desposition_chose_div_new").hide();
					$("#camera_config_item_saveposition").find("img").css("opacity",0.5);
				}
			})
			//自动聚焦
			$("#camera_config_item_focuse").bind("click",function(){
				var autofocus=$("#camera_config_item_focuse").data("focuse");
				$.ajax({
					type:"post",
					url:that.samewifi?"/v1/mobiles/camera/settings/autofocus":"/relay/"+that.cid+"/v1/mobiles/camera/settings/autofocus",
					data:{autofocus:autofocus},
					success:function(data, textStatus){
						if($("#camera_config_item_focuse").data("focuse") === 1){
							$("#camera_config_item_focuse").data("focuse",0);
							$("#camera_config_item_focuse").find("img").css("opacity",1);
						}else{
							$("#camera_config_item_focuse").data("focuse",1);
							$("#camera_config_item_focuse").find("img").css("opacity",0.5);
						}
					},
					error:function(){
						$.fn.getProcess("show",{p_text:lang.setContent("camera_16"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
					}
				})
			});
			$("#camera_operate_getPic_new").bind("click",function(){
				camera.photograph();
			});
			$("#camera_config_item_light").bind("click",function(){
				var flashlight_state=$("#camera_config_item_light").data("flashlight");
				$.ajax({
					type:"post",
					url:that.samewifi?"/v1/mobiles/camera/flashlight":"/relay/"+that.cid+"/v1/mobiles/camera/flashlight",
					data:{open:flashlight_state},
					success:function(){
						if(flashlight_state===0){
							$("#camera_config_item_light").data("flashlight",1);
							$("#camera_config_item_light").find("img").css("opacity",0.5);
						}else{
							$("#camera_config_item_light").data("flashlight",0);
							$("#camera_config_item_light").find("img").css("opacity",1);
						}
					},
					error:function(){
						$.fn.getProcess("show",{p_text:lang.setContent("camera_5"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
					}
				});
			});
			//反转摄像头
			$("#camera_config_item_exchange").bind("click",function(){
					var params={open:2};
					if(camera.curent_proportion !== ""){
						params.ratio=camera.curent_proportion;
					}
					$.ajax({
						type:"post",
						url:that.samewifi?"/v1/mobiles/camera":"/relay/"+that.cid+"/v1/mobiles/camera",
						data:params,
						success:function(data){
							if(data.cameraid !== undefined){
								camera.frontCamera=data.cameraid;
							}
							//反转摄像头之后，闪光灯自动关闭了
							$("#camera_config_item_light").data("flashlight",1);
							$("#camera_config_item_light").find("img").css("opacity",0.5);
							//反转摄像头之后自动预览
							if(!camera.start){
								$("#camera_operate_button_switch").find("img").addClass("camera_open").removeClass("camera_close");
						   		$("#camera_switch_bar").css("background-color","#fc4847");
						   		camera.setCameraSocket();
						   		camera.start=true;
							}
							
						    camera.closeConfigDiv();
							

						},
						error:function(){
							$.fn.getProcess("show",{p_text:lang.setContent("camera_5"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
						}
					})
				
			});	
			//图片传输速度
			$('.single-slider').jRange({
				from:1,//开始于
				to: 5,//结束于
				step: 1,//一次滑动多少
				scale: [lang.setContent("camera_34"),lang.setContent("camera_35"),lang.setContent("camera_36"),lang.setContent("camera_37"),lang.setContent("camera_38")],//分割点
				format: '%s',//格式化格式
				width: 200,//宽度
				showLabels: false,
				showScale: true
			});
		},
		//关闭设置框
		closeConfigDiv:function(){
			$("#camera_config_div").hide();
			$("#camera_config_show_button").find("i").removeClass("uk-icon-close").addClass("uk-icon-cog");

		},
		//设置传输速度
		setQuality:function(){
			var that=this;
			var qa=$(".single-slider").val();
			$.ajax({
				type:"post",
				url:that.samewifi?"/v1/mobiles/camera/settings/speed":"/relay/"+that.cid+"/v1/mobiles/camera/settings/speed",
				data:{speed:qa},
				success:function(){
					
				}
			})
		},
		//获取预览图
		startCamera:function(){
			var that=this;
			camera.start=true;
			if(!window.WebSocket){
				//不支持websocket时候用长轮循的方式
				camera.interval=setInterval(camera.getCameraImg,200);
			}else{
				camera.cameraSocket.binaryType = "arraybuffer";
				camera.cameraSocket.onmessage =function(event){
					if(that.version=="iOS"){
						var byteData=event.data.substring(0,event.data.indexOf("rotate"));
					    var rotate=event.data.substring(event.data.indexOf("rotate")+6);
					    camera.setCameraImg(byteData,rotate);
					}else{
						camera.setCameraImgByByte(event.data);
					}
					event=null;
				}
			}
		},
		//获取到图片字节流数据，再转换
		setCameraImgByByte:function(result){
			//判断是否是关闭操作
			var that=this;
			if(result === "close"){
				$("#camera_config_item_light").data("flashlight",1).css("color","#fff");
				$("#camera_config_item_light").find("img").css("opacity",0.5);
				camera.open=false;
				camera.start=false;
				$("#camera_operate_button_switch").find("img").addClass("camera_close").removeClass("camera_open");
				$("#camera_switch_bar").css("background-color","#ccc");
				if(camera.cameraSocket != null){
					//关闭之后接收的照片信息不展示
					camera.cameraSocket.onmessage =function(event){
					event=null;
					}
				}
				return;
			}
			//闪光灯状态接受
			if(typeof result == "string" && result.indexOf("flashlight") !== -1){
				var flashlight_state=result.substring(10,11);
				if(flashlight_state === "1"){//开启闪光灯
					$("#camera_config_item_light").data("flashlight",0);
					$("#camera_config_item_light").find("img").css("opacity",1);
				}else if(flashlight_state === "0"){//关闭闪光灯
					$("#camera_config_item_light").data("flashlight",1);
					$("#camera_config_item_light").find("img").css("opacity",0.5);
				}
				return;
			}
			var bytes = new Uint8Array(result);
		    var data = "";
		    var len = bytes.byteLength;
		    for (var i = 0; i < len; ++i) {
		        data += String.fromCharCode(bytes[i]);
		    }
		    var byteData=data.substring(0,data.indexOf("rotate"));
		    var rotate="";
		    if(that.version=="iOS"){
		    	rotate=data.substring(data.indexOf("rotate")+6);
		    }else{
		    	rotate=data.substring(data.indexOf("rotate")+6,data.indexOf("direction"));
		    }
			var direction=data.substring(data.indexOf("direction"));
			camera.setCameraImg(byteData,rotate,direction);
		},
		//展示图片，调整角度
		setCameraImg:function(byteData,rotate,direction){
			var that=this;
			if(camera.rotateData == rotate){
				$("#camera_img_new").attr("src","data:;base64,"+byteData);
			}else{	
					camera.rotateData=rotate;
					switch(rotate){
						case "90":
							$("#camera_img_new").attr("src","data:;base64,"+byteData);
							$("#camera_table_new").removeClass("camera_class_0").removeClass("camera_class_90").removeClass("camera_class_270").removeClass("camera_class_180").addClass("camera_class_90");
						break;
						case "180":
							$("#camera_img_new").attr("src","data:;base64,"+byteData);
							$("#camera_table_new").removeClass("camera_class_90").removeClass("camera_class_270").removeClass("class_0").addClass("camera_class_180");
							break;
						case "270":
							$("#camera_img_new").attr("src","data:;base64,"+byteData);
							$("#camera_table_new").removeClass("camera_class_90").removeClass("camera_class_180").removeClass("camera_class_0").addClass("camera_class_270");
							break;
						default:
							$("#camera_img_new").attr("src","data:;base64,"+byteData);
							$("#camera_table_new").removeClass("camera_class_90").removeClass("camera_class_180").removeClass("camera_class_270").addClass("camera_class_0");
							break;
						}
			}
			if(that.version !=="iOS"){
				if(direction && direction === "direction1" && camera.frontCamera === 1){
					if($("#camera_table_new").hasClass("no_angle")){
						$("#camera_table_new").addClass("adjust_angle").removeClass("no_angle");
					}
				}else{
					if($("#camera_table_new").hasClass("adjust_angle")){
						$("#camera_table_new").addClass("no_angle").removeClass("adjust_angle");
					}
				}
			}
			
			byteData=null;
			rotate=null;
		},
	    //继续预览
	    continueCamera:function(){
			camera.openCamera();
	    },
		//停止预览(关闭相机)
		stopCamera:function(){
			var that=this;
			camera.start=false;
			var params={open:0};
			if(camera.curent_proportion !== ""){
				params.ratio=camera.curent_proportion;
			}
			$.ajax({
				type:"post",
				url:that.samewifi?"/v1/mobiles/camera":"/relay/"+that.cid+"/v1/mobiles/camera",
				data:params,
				success:function(){
					//停止预览之后后台关闭了摄像头
					if(camera.interval != null){
						clearInterval(camera.interval);
					}
					//关闭相机之后，旋转摄像头图标隐藏,闪光灯关闭
					$("#camera_config_item_light").data("flashlight",1).css("color","#fff");
					$("#camera_config_item_light").find("img").css("opacity",0.5);
					//$("#camera_exchange_span").hide();
					camera.open=false;
					$("#camera_operate_button_switch").find("img").addClass("camera_close").removeClass("camera_open");
					$("#camera_switch_bar").css("background-color","#ccc");
					if(camera.cameraSocket != null){
						//关闭之后接收的照片信息不展示
						camera.cameraSocket.onmessage =function(event){
						event=null;
						}
					}
				}
			})
		},
		//点击拍照
		photograph:function(){
			var that=this;
			if(!camera.open){
				$.fn.getProcess("show",{p_text:lang.setContent("camera_21"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1500)});
				return;
			}
			var location=0;
			if(camera.saveDestination == "pc"){//保存到电脑
				location=0;
				$("#download-iframe").attr("src",that.samewifi?"/v1/mobiles/camera/photo?location=0":"/relay/"+that.cid+"/v1/mobiles/camera/photo?location=0");
			}else if(camera.saveDestination == "phone"){//保存到手机
				location=1;
				$.ajax({
					type:"get",
					cache:false,
					url:that.samewifi?"/v1/mobiles/camera/photo":"/relay/"+that.cid+"/v1/mobiles/camera/photo",
					data:{location:1},
					success:function(){
						$.fn.getProcess("show",{p_text:lang.setContent("camera_6"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
					},
					error:function(){
						$.fn.getProcess("show",{p_text:lang.setContent("camera_7"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
					}
				})
			}
		}
	};
	return camera;
})