define(["jquery","cookie","lang"],function($,cookie,lang){
	mirror={
		mirrorSocket:null,
		samewifi:cookie.getCookie("zapya_webshare_samewifi")=="false"?false:true,
		cid:"cid"+cookie.getCookie("cid"),
		relayIp:cookie.getCookie("relayIp"),
		relayPort:cookie.getCookie("relayPort"),
		phoneWidth:cookie.getCookie("phoneWidth"),
		phoneHeight:cookie.getCookie("phoneHeight"),
		noticeShow:false,
		setMirrorSocket:function(){
			var that=this;
			var socketIp=cookie.getCookie("socketIp");
			var socketPort=cookie.getCookie("socketPort");
			var mirrorSocketUrl="";
			if (window.WebSocket) {
				if(that.samewifi){//同一wifi下
					if(socketIp !== null && socketPort !== null && socketIp !== "" && socketPort !== ""){//在device里已经获取到sockt的ip和socket
						mirrorSocketUrl="ws://"+socketIp+":"+socketPort+"/v1/mobiles/screen";
					    mirror.mirrorSocket=new WebSocket(mirrorSocketUrl);
						mirror.mirrorSocket.onclose=function(){
							that.mirrorSocket = null;
							$("#mirror_img").unbind("mousedown");
							$("#mirror_img").unbind("mousemove");  
                            $("#mirror_img").unbind("mouseup");
						}
						mirror.mirrorSocket.onmessage=function(event){
							if(event.data === "error0"){
								if(!that.noticeShow){
									$(".mirror-notice-label").text(lang.setContent("mirror_0"));
									$("#mirror_notice").show();
									that.noticeShow=true;
								}
							}else if(event.data === "error1"){
								if(!that.noticeShow){
									$(".mirror-notice-label").text(lang.setContent("mirror_1"));
									$("#mirror_notice").show();
									that.noticeShow=true;
								}
							}else if(event.data === "error2"){
								if(!that.noticeShow){
									$(".mirror-notice-label").text(lang.setContent("mirror_2"));
									$("#mirror_notice").show();
									that.noticeShow=true;
								}
							}else if(event.data === "error3"){
								if(!that.noticeShow){
									$(".mirror-notice-label").text(lang.setContent("mirror_3"));
								    $("#mirror_notice").show();
								    that.noticeShow=true;
								}
							}else{
								mirror.mirrorSocket.binaryType = "arraybuffer";
								mirror.setMirrorImg(event.data);
							}
						}
					}else{
						$.ajax({
							type:"get",
							url:"/v1/mobiles/websocketserver",
							success:function(socketResult){
								cookie.setCookie("socketIp",socketResult.ip);
								cookie.setCookie("socketPort",socketResult.port);
								var mirrorSocketUrl="ws://"+socketResult.ip+":"+socketResult.port+"v1/mobiles/screen";
								mirror.mirrorSocket=new WebSocket(mirrorSocketUrl);
								mirror.mirrorSocket.onclose=function(){
									$("#mirror_img").unbind("mousedown");
									$("#mirror_img").unbind("mousemove");  
		                            $("#mirror_img").unbind("mouseup");
								}
								mirror.mirrorSocket.binaryType = "arraybuffer";
								mirror.mirrorSocket.onmessage=function(event){
									if(event.data === "error0"){
										if(!that.noticeShow){
											$(".mirror-notice-label").text(lang.setContent("mirror_0"));
											$("#mirror_notice").show();
											that.noticeShow=true;
										}
									}else if(event.data === "error1"){
										if(!that.noticeShow){
											$(".mirror-notice-label").text(lang.setContent("mirror_1"));
											$("#mirror_notice").show();
											that.noticeShow=true;
										}
									}else if(event.data === "error2"){
										if(!that.noticeShow){
											$(".mirror-notice-label").text(lang.setContent("mirror_2"));
											$("#mirror_notice").show();
											that.noticeShow=true;
										}
									}else if(event.data === "error3"){
										if(!that.noticeShow){
											$(".mirror-notice-label").text(lang.setContent("mirror_3"));
										    $("#mirror_notice").show();
										    that.noticeShow=true;
										}
									}else{
										mirror.mirrorSocket.binaryType = "arraybuffer";
										mirror.setMirrorImg(event.data);
									}
								}
							}
						})
					}
				}else{//不同wifi下
					var socketUrl="ws://"+that.relayIp+":"+that.relayPort+"/relayws/"+that.cid+"v1/mobiles/screen";
					mirror.mirrorSocket=new WebSocket(socketUrl);
					mirror.mirrorSocket.onclose=function(){
						that.mirrorSocket = null
					}
					
				}
			           
			}else{
			    return;
			}
		},
		resize:function(){
			//获取屏幕高度
				var that=this;
				var mirror_li_height=$(".airmirror-panel-li").height();
				var mirror_img_container_height=mirror_li_height-105;
				if(mirror_img_container_height > 550){
					mirror_img_container_height =550;
				}
				$("#mirror_img_container").height(mirror_img_container_height);
				var phoneProportion = that.phoneWidth/that.phoneHeight;
				var mirror_img_container_width=mirror_img_container_height*phoneProportion;
				$("#mirror_img_container").width(mirror_img_container_width);
				$("#mirror_top_bar").width(mirror_img_container_width);
				$("#mirror_bottom_bar").width(mirror_img_container_width);
				that.drag(mirror_img_container_width,mirror_img_container_height);
		},
		setMirrorImg:function(img){
			var bytes = new Uint8Array(img);
		    var data = "";
		    var len = bytes.byteLength;
		    for (var i = 0; i < len; ++i) {
		        data += String.fromCharCode(bytes[i]);
		    }
			$("#mirror_img").attr("src","data:;base64,"+data);
		},
		init:function(){
			var that=this;
			that.noticeShow=false;
			if(that.mirrorSocket === null){
				that.setMirrorSocket();
				that.resize();
			}
			$("#mirror_notice_head").unbind("click").bind("click",function(){
				$("#mirror_notice").hide();
			})
			$(".mirror_tool_bar li").unbind("click").bind("click",function(){
				if(that.mirrorSocket !== null){
					var toolParam={action:4,k:$(this).data("tool")};
	  				that.mirrorSocket.send(JSON.stringify(toolParam));
				}
			})
			
		},
		closeSocket:function(){
			if(this.mirrorSocket !== null){
				this.mirrorSocket.close();
			}
		},
		drag:function(width,height){
			var that=this;
			var hasMove=false;
			var obj=$("#mirror_img");
			obj.bind("mousedown",start);  
			var start="";
			function start(event){
				var offset = obj.offset();
				hasMove=false;
				if(event.button==0){
					gapX=(event.pageX - offset.left)/width; 
					gapY=(event.pageY - offset.top)/height; 
					if(that.mirrorSocket !== null){
	  					console.log("按下: " + gapX + "  Y: " + gapY);
	  					var startParam={action:0,x:gapX,y:gapY};
	  					that.mirrorSocket.send(JSON.stringify(startParam));
	  				}
				    obj.bind("mouseup",stop);
				    obj.bind("mousemove",move); 
				    
				}
				return false;
			}
			function move(e){  
				hasMove=true;
				var offset = obj.offset();
				var moveX = (e.pageX - offset.left)/width;
  				var moveY = (e.pageY - offset.top)/height;
  				if(that.mirrorSocket !== null){
	  				console.log("滑动x="+moveX+";y="+moveY);
	  				var moveParam={action:2,x:moveX,y:moveY};
	  				that.mirrorSocket.send(JSON.stringify(moveParam));
	  			}
                
                return false;//阻止默认事件或冒泡  
            }  
            function stop(){ 
            	var offset = obj.offset();
				var stopX = (event.pageX - offset.left)/width;
  				var stopY = (event.pageY - offset.top)/height;
  				if(that.mirrorSocket !== null){
  					if(hasMove){
		  				console.log("抬起x="+stopX+";y="+stopY)
		  				var stopParam={action:1,x:stopX,y:stopY};
		  				that.mirrorSocket.send(JSON.stringify(stopParam));
		  			}else{
		  				console.log("click")
		  				var clickParam={action:3,x:stopX,y:stopY};
	  					that.mirrorSocket.send(JSON.stringify(clickParam));
		  			}
  				}
                

                
                hasMove=false;  //还原标识，以便下一次使用 
                //解绑定，这一步很必要，前面有解释 
                obj.unbind("mousemove",move);  
                obj.unbind("mouseup",stop);  
            }  
		}

	};
	return mirror;
})