define(["jquery","zapya","lang","commonHandler","jplayer"],function($,zapya,lang,common,jplayer){
	audio_phone={
		audioDataDom:[],
		playing_path:"",//正在播放的音乐路径
		player_state:"unplayed",//当前播放器的播放状态
		//获取视频
		init:function() {
			$("#audio-permision-notice").hide();
			$("#audio_sort_bar li[data-key='audioname']").addClass("select");
			$("#audio_sort_bar li[data-key='artist']").removeClass("select");
			$("#audio_container").show();
			var that=this;
			$("#music-empty-notice").hide();
			$("#audio-loading-module").show();
			$.ajax({
				type: 'get',
				url: zapya.samewifi?"/v1/mobiles/audios":"/relay/"+zapya.cid+"/v1/mobiles/audios",
				cache:false,
				success: function(data) {
					$("#audio-loading-module").hide();
					if(data.length === 0){
						$("#music-empty-notice").show();
					}
					that.audioData=data;
					that.winFrame(data);
				},
				error:function(XMLHttpRequest){
					$("#audio-loading-module").hide();
					$("#audio_container").empty();
					if(XMLHttpRequest.status === 403){
						$("#audio-permision-notice").show();
					}	
				},
				complete:function(XHR, TS){
					XHR = null;
				}
			});
			that.initPlayer();
		},
		privacySure:function(){
			var that=this;
			$.ajax({
				type: 'get',
				url: zapya.samewifi?"/v1/mobiles/audios":"/relay/"+zapya.cid+"/v1/mobiles/audios",
				cache:false,
				success:function(){
					if(!$("#audio-permision-notice").is(":hidden")){
						$(".refresh-icon").trigger("click");
					}
				},
				error:function(XMLHttpRequest){
					if(XMLHttpRequest.status === 403){
						$("#audio_container").hide();
						$("#audio-permision-notice").show();
						$("#jquery_jplayer_audio").jPlayer("clearMedia");
					}	
				}
			});
		},
		winFrame:function(data){
			var that=this;
			var htmls = [];
			that.audioDataDom=[];
			$("#audio_container").empty();
			//按歌名排序
			data.sort(function compareFunction(a1,a2){
				return a1.title.localeCompare(a2.title);
			})
			$.each(data,function(index,info){
				var path=encodeURIComponent(info.path);
				var duration=zapya.utils.toTimeByLong(info.duration);
				var artist=info.artist;
				if(artist === "<unknown>"){
					artist=lang.setContent("audio_8");
				}
				var dom="<div class='audio_item_container uk-width-1-1 unplayed' data-artist=\""+artist+"\" data-title=\""+info.title+"\" data-path=\""+path+"\">"+
								'<div class="audio_bg_img"><img src="i/phone/audio.png"></div>'+
	    						'<div class="audio_info">'+
	    							'<label class="audio_label uk-text-truncate">'+info.title+'</label>'+
	    							'<label class="audio_artist">'+info.artist+'</label>'+
	    							'<label class="audio_duration">&nbsp&nbsp|&nbsp&nbsp'+duration+'</label>'+
	    						'</div>'+
	    						'<div class="audio_controll_div"><i class="uk-icon-play-circle audio-play-circle"></i></div>'+
	    						'<div class="chosen_bt audio_chosen_bt" data-path="'+path+'">'+
	    							'<i class="uk-icon-square-o square-o"></i>'+
	    						'</div>'+
	    				'</div>';
				htmls.push(dom);
			});
			$("#audio_container").append(htmls.join(""));
			$("#audio_container .audio_item_container").each(function(){
				that.audioDataDom.push($(this));
			})
			this.addHandler();
		},
		addHandler:function(){
			var that=this;
			$("#audio_container").off("click").on("click",".audio_item_container",function(){
				if(! $("#oprate_bar").is(":hidden")){
					if($(this).find(".chosen_bt i").hasClass("square-o")){
						$(this).find(".chosen_bt i").attr("class","uk-icon-check-square check-square")
					}else{
						$(this).find(".chosen_bt i").attr("class","uk-icon-square-o square-o")
					}
					common.isSelectAll();
				}else{
					var state=$(this).data('state');
					if($(this).hasClass("unplayed")){//未播放状态
						var path=$(this).data("path");
						var audio_src=zapya.samewifi?"/v1/mobiles/storages/files?path="+path:"/relay/"+zapya.cid+"/v1/mobiles/storages/files?path="+path;
						$("#jquery_jplayer_audio").jPlayer("setMedia", {
					         mp3: audio_src
						}).jPlayer("play");
						$(".audio_item_container.playing").find(".audio_controll_div").find("i").attr("class","uk-icon-play-circle audio-play-circle");
						$(".audio_item_container.playing").removeClass("playing").addClass("unplayed")
						$(this).addClass("playing").removeClass("unplayed");
						$(this).find(".audio_controll_div").find("i").attr("class","uk-icon-pause audio-pause");
						that.playing_path=$(this).data("path");
						that.player_state="playing";
					}else if($(this).hasClass("playing")){//正在播放
						$("#jquery_jplayer_audio").jPlayer("pause");
						$(this).removeClass("playing").addClass("pause");
						$(this).find(".audio_controll_div").find("i").attr("class","uk-icon-play-circle audio-play-circle");
						that.player_state="pause";
					}else if($(this).hasClass("pause")){//暂停播放
						$("#jquery_jplayer_audio").jPlayer("play");
						$(this).removeClass("pause").addClass("playing");
						$(this).find(".audio_controll_div").find("i").attr("class","uk-icon-pause audio-pause");
						that.player_state="playing";
					}
				}
			});
			//排序点击
			$("#audio_sort_bar li").unbind("click").bind("click",function(){
				that.audioDataDom=[];
				$("#audio_container .audio_item_container").each(function(){
					that.audioDataDom.push($(this));
				})
				if(!$("#audio-permision-notice").is(":hidden")){
					return;
				}
				if(!$(this).hasClass("select")){
					$("#audio_sort_bar li.select").removeClass("select");
					$(this).addClass("select");
					var key=$(this).data("key");
					$("#audio_container").empty();
					that.audioDataDom.sort(function compareFunction(a1,a2){
						if(key === "artist"){
							return (a1.data("artist")+"").localeCompare(a2.data("artist")+"");
						}else{
							return (a1.data("title")+"").localeCompare(a2.data("title")+"");
						}
					})
					$.each(that.audioDataDom,function(){
						$("#audio_container").append(this);
					})
					that.addHandler()
				}
			})
			//播放器监听事件
			$("#jquery_jplayer_audio").unbind($.jPlayer.event.ended).bind($.jPlayer.event.ended,function(event){
				var nextDom=$(".playing").next();
				var path=nextDom.data("path");
				var audio_src=zapya.samewifi?"/v1/mobiles/storages/files?path="+path:"/relay/"+zapya.cid+"/v1/mobiles/storages/files?path="+path;
				$("#jquery_jplayer_audio").jPlayer("setMedia", {
					mp3: audio_src
				}).jPlayer("play");
				$(".playing").find(".uk-icon-pause").attr("class","uk-icon-play-circle audio-play-circle");
				$(".playing").removeClass("playing").addClass("unplayed");
				nextDom.removeClass("unplayed").addClass("playing");
				nextDom.find(".audio-play-circle").attr("class","uk-icon-pause audio-pause");
			})
		},
		deleteOrDownloadAudio:function(opt){
			var that=this;
			var audiopath="";
			$(".check-square").each(function(){
				var path=$(this).parent().data("path");
					audiopath+=path+",";
			})
			if(audiopath == ""){return;}
			audiopath=audiopath.substring(0,audiopath.length-1);
			if(opt == "delete"){
				$.fn.getProcess("show",
		    		{ 
			  			p_text:lang.setContent("common_7"),
			  			p_icon:"",
			  			p_commit:lang.setContent("common_8"),
			  			p_cancel:lang.setContent("common_9"),
			  			p_fn_commit:function(){common.deleteFile(audiopath,that.afterDelete);},
			  			p_fn_cancel:function(){$.fn.getProcess("hide");},
					}
				);
			}else{
				common.downloadFiles(audiopath);
			}
		},
		afterDelete:function(){
			var that=this;
			$.fn.getProcess("hide");
			$(".check-square").each(function(){
				if($(this).parent().parent().hasClass("playing")){
					$("#jquery_jplayer_audio").jPlayer("stop");
				}
			})
			$(".check-square").parent().parent().remove();
			if($(".audio_item_container").length === 0){
				$("#music-empty-notice").show();
			}
			common.isSelectAll();
		},
		initPlayer:function(){
			$("#jquery_jplayer_audio").jPlayer({
			  	swfPath: zapya.samewifi?"/jplayer/jquery.jplayer.swf":"/relay/"+zapya.cid+"/jplayer/jquery.jplayer.swf",
				supplied: " oga, mp3",
			  });
		}
	};
	return audio_phone;
})