define(["jquery","cookie","lang","jRange"],function($,cookie,lang,jRange){
	camera_phone={
		open:false,
		start:false,
		interval:null,
		saveDestination:"phone",
		flashlight:0,
		cameraSocket:null,
		rotateData:90,
		frontCamera:false,
		curent_proportion:"",//当前图片比例
		container_width:0,
		container_height:0,
		samewifi:cookie.getCookie("zapya_webshare_samewifi")=="false"?false:true,
		cid:"cid"+cookie.getCookie("cid"),
		relayIp:cookie.getCookie("relayIp"),
		relayPort:cookie.getCookie("relayPort"),
		version:cookie.getCookie("version"),
		//打开相机
		openCamera:function(){
			$("#camera-permision-notice").hide();
			var that=this;
			that.open=true;
			that.start=true;
			$("#camera_operate_button_switch").find("img").addClass("camera_open").removeClass("camera_close");
			$("#camera_switch_bar").css("background-color","#fc4847");
			var params={open:1};
			if(that.curent_proportion !== ""){
				params.ratio=that.curent_proportion;
			}
			$.ajax({
				type:"post",
				url:that.samewifi?"/v1/mobiles/camera":"/relay/"+that.cid+"/v1/mobiles/camera",
				data:params,
				success:function(data, textStatus){
					if(that.curent_proportion === ""){
						if(data.ratios !== undefined){
							that.curent_proportion=data.ratios[0];
							that.resize();
							that.setProportions(data.ratios);
						}
					}
					
					that.setCameraSocket();
					
				},
				error:function(XMLHttpRequest){
					$("#camera_operate_button_switch").find("img").addClass("camera_close").removeClass("camera_open");
					$("#camera_switch_bar").css("background-color","#ccc");
					if(XMLHttpRequest.status === 403){
						$("#camera-permision-notice").show();
					}	
				}
			})
		},
		//建立相机的websocket连接
		setCameraSocket:function(){
			var that=this;
			var cameraSocketUrl="";
			var socketIp=cookie.getCookie("socketIp");
			var socketPort=cookie.getCookie("socketPort");
			if (window.WebSocket) {
				if(that.samewifi){//同一wifi下
					if(socketIp !== null && socketPort !== null && socketIp !== "" && socketPort !== ""){//在device里已经获取到sockt的ip和socket
						cameraSocketUrl="ws://"+socketIp+":"+socketPort+"/v1/mobiles/camera/preview";
						that.cameraSocket=new WebSocket(cameraSocketUrl);
						that.cameraSocket.onclose=function(){
							that.open=false;
							that.start=false;
						}
						that.startCamera();
					}else{
						$.ajax({
							type:"get",
							url:"/v1/mobiles/websocketserver",
							success:function(socketResult){
								cookie.setCookie("socketIp",socketResult.ip);
								cookie.setCookie("socketPort",socketResult.port);
								var cameraSocketUrl="ws://"+socketResult.ip+":"+socketResult.port+"/v1/mobiles/camera/preview";
								that.cameraSocket=new WebSocket(cameraSocketUrl);
								that.cameraSocket.onclose=function(){
									that.open=false;
									that.start=false;
								}
								that.startCamera();
							}
						})
					}
				}else{//不同wifi下
					var socketUrl="ws://"+that.relayIp+":"+that.relayPort+"/relayws/"+that.cid+"/v1/mobiles/camera/preview";
					that.cameraSocket=new WebSocket(socketUrl);
					that.cameraSocket.onclose=function(){
						that.open=false;
						that.start=false;
					}
					that.startCamera();
				}
			           
			}else{
			    that.startCamera();
			    return;
			}
		},
		//关闭相机
		closeCamera:function(){
			var that=this;
			var params={open:0};
			if(that.curent_proportion !== ""){
				params.ratio=that.curent_proportion;
			}
			$.ajax({
				type:"post",
				url:that.samewifi?"/v1/mobiles/camera":"/relay/"+that.cid+"/v1/mobiles/camera",
				data:params,
				success:function(data, textStatus){
					that.open=false;
				},
				error:function(){
					
				}
			})
		},
		//设置比例选择
		setProportions:function(arry){
			var that=this;
			var parryDom=[];
			$("#proportionSelectDiv ul").empty();
			$.each(arry,function(index,ption){
				var doms="<li";
				if(index == 0){
					doms+=" class='selected'>"+ption+"</li>";
				}else{
					doms+=">"+ption+"</li>";
				}
				parryDom.push(doms);
			});
			$("#proportionSelectDiv ul").append(parryDom.join(""));
			$("#proportionSelectDiv li").bind("click",function(){
				if(!$(this).hasClass("selected")){
					$("#proportionSelectDiv li.selected").removeClass("selected");
					$(this).addClass("selected");
					var selectP=$(this).html();
					that.curent_proportion=selectP;
					$.ajax({
						type:"POST",
						url:that.samewifi?"/v1/mobiles/camera/settings/ratio":"/relay/"+that.cid+"/v1/mobiles/camera/settings/ratio",
						data:{ratio:selectP},
						success:function(){
							that.resize();
							that.setCameraSocket();
						}
					})
				}
			})
		},
		//ajax方式拉取图片信息
		getCameraImg:function(){
			var that=this;
			$.ajax({
				type:"get",
				url:that.samewifi?"/v1/mobiles/camera/preview":"/relay/"+that.cid+"/v1/mobiles/camera/preview",
				cache:false,
				success:function(data){
					$("#camera_img").show();
					var byteData=data.substring(0,data.indexOf("rotate"));
					var rotate;
					if(that.version=="Android"){
						rotate=data.substring(data.indexOf("rotate")+6,data.indexOf("direction"));
					}else{
						rotate=data.substring(data.indexOf("rotate")+6);
					}
					that.setCameraImg(byteData,rotate);
					data=null;
				}
			})
		},
		resize:function(){
			var that=this;
			var camera_height=$("#camera_content").height();
			var camera_width=$("#camera_content").width();
			var proportion=""
			if(that.curent_proportion === ""){
				proportion="16:9"; 
			}else{
				proportion=that.curent_proportion;
			}
			var het=Number(proportion.substring(proportion.indexOf(":")+1,proportion.length));
			var wth=Number(proportion.substring(0,proportion.indexOf(":")));
			var adjust_width=camera_height*wth/het;
			if(adjust_width<camera_width){
				var margin_left=(camera_width-adjust_width-30)/2;//30是下面操作栏的宽度
				$("#camera_img").height(camera_height).width(adjust_width)
			}else{
				var adjust_height=camera_width*het/wth;
				var margin_top=(camera_height-adjust_height)/2;
				$("#camera_img").height(adjust_height).width(camera_width);
			}
		},
		init:function(){
			//获取屏幕高度
			var that=this;
			$("#camera_module").height($(window).height()-$("#nav_bar_header").height());
			$("#camera_content").height($("#camera_module").height()-$("#camera_head").height()-$("#camera_bottom").height());
			that.container_height=$("#camera_content").height();
			that.container_width=$("#camera_content").width();
			$("#camera_content").css("line-height",that.container_height+"px");
			$("#camera_config_item_help").click(function(){
				$("#camera_notice").toggle();
				if($("#camera_notice").is(":hidden")){
					$(this).find("img").css("opacity",0.5);
				}else{
					$(this).find("img").css("opacity",1);
				}
			})
			$("#camera_notice_head i").click(function(){
				$("#camera_notice").hide();
				$("#camera_config_item_help").find("img").css("opacity",0.5);
			});
			//辅助线
			$("#camera_config_item_addline").click(function(){
				$("#help_lines_div").toggle();
				if($("#help_lines_div").is(":hidden")){
					$(this).find("img").css("opacity",0.5);
				}else{
					$(this).find("img").css("opacity",1);
				}
			});
			//设置比例
			$("#camera_config_item_proportion img").click(function(){
				$("#proportionSelectDiv").toggle();
				if($("#proportionSelectDiv").is(":hidden")){
					$(this).css("opacity",0.5);
				}else{
					$(this).css("opacity",1);
					//设置质量，保存位置div隐藏
					$("#qualitySelectDiv").hide();
					$("#camera_config_item_quality img").css("opacity",0.5);
					$("#save_desposition_chose_div_new").hide();
					$("#camera_config_item_saveposition").find("img").css("opacity",0.5);
				}
			});
			$("#camera_config_item_quality img").click(function(){
				$("#qualitySelectDiv").toggle();
				if($("#qualitySelectDiv").is(":hidden")){
					$(this).css("opacity",0.5);
				}else{
					$(this).css("opacity",1);
					//设置比例,保存位置div隐藏
					$("#proportionSelectDiv").hide();
					$("#camera_config_item_proportion img").css("opacity",0.5);
					$("#save_desposition_chose_div_new").hide();
					$("#camera_config_item_saveposition").find("img").css("opacity",0.5);
				}
			});
			$("#camera_operate_button_switch").bind("click",function(){
				if($(this).find("img").hasClass("camera_close")){//相机关闭状态
					that.continueCamera();
				}else{
					that.stopCamera();
				}
			});
			$("#camera_config_item_saveposition img").bind("click",function(){
				$("#save_desposition_chose_div_new").toggle();
				if($("#save_desposition_chose_div_new").is(":hidden")){
					$(this).find("img").css("opacity",0.5);
				}else{
					$(this).find("img").css("opacity",1);
					//设置比例，设置质量div隐藏
					$("#qualitySelectDiv").hide();
					$("#camera_config_item_quality img").css("opacity",0.5);
					$("#proportionSelectDiv").hide();
					$("#camera_config_item_proportion img").css("opacity",0.5);
				}
			});
			$("#save_desposition_chose_div_new input[type=radio]").bind("click",function(){
				that.saveDestination=$("#save_desposition_chose_div_new input[type=radio]:checked").val();
			});
			$("#save_desposition_chose_div_new label").bind("click",function(){
				var $input=$(this).prev("input");
				$input.prop("checked", "checked");
				that.saveDestination=$input.val();
			});
			//设置
			$("#camera_config_show_button").bind("click",function(){
				$("#camera_config_div").toggle();
				if($(this).find("i").hasClass("uk-icon-cog")){
					$(this).find("i").removeClass("uk-icon-cog").addClass("uk-icon-close");
				}else{
					$(this).find("i").removeClass("uk-icon-close").addClass("uk-icon-cog");
					$("#qualitySelectDiv").hide();
					$("#camera_config_item_quality img").css("opacity",0.5);
					$("#proportionSelectDiv").hide();
					$("#camera_config_item_proportion img").css("opacity",0.5);
					$("#save_desposition_chose_div_new").hide();
					$("#camera_config_item_saveposition").find("img").css("opacity",0.5);
				}
			})
			//自动聚焦
			$("#camera_config_item_focuse").bind("click",function(){
				var autofocus=$("#camera_config_item_focuse").data("focuse");
				$.ajax({
					type:"post",
					url:that.samewifi?"/v1/mobiles/camera/settings/autofocus":"/relay/"+that.cid+"/v1/mobiles/camera/settings/autofocus",
					data:{autofocus:autofocus},
					success:function(data, textStatus){
						if($("#camera_config_item_focuse").data("focuse") === 1){
							$("#camera_config_item_focuse").data("focuse",0);
							$("#camera_config_item_focuse").find("img").css("opacity",1);
						}else{
							$("#camera_config_item_focuse").data("focuse",1);
							$("#camera_config_item_focuse").find("img").css("opacity",0.5);
						}
					},
					error:function(){
						$.fn.getProcess("show",{p_text:lang.setContent("camera_16"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
					}
				})
			});
			$("#camera_operate_getPic_new").bind("click",function(){
				that.photograph();
			});
			$("#camera_config_item_light").bind("click",function(){
				var flashlight_state=$("#camera_config_item_light").data("flashlight");
				$.ajax({
					type:"post",
					url:that.samewifi?"/v1/mobiles/camera/flashlight":"/relay/"+that.cid+"/v1/mobiles/camera/flashlight",
					data:{open:flashlight_state},
					success:function(){
						if(flashlight_state===0){
							$("#camera_config_item_light").data("flashlight",1);
							$("#camera_config_item_light").find("img").css("opacity",0.5);
						}else{
							$("#camera_config_item_light").data("flashlight",0);
							$("#camera_config_item_light").find("img").css("opacity",1);
						}
					},
					error:function(){
						$.fn.getProcess("show",{p_text:lang.setContent("camera_5"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
					}
				});
			});
			//反转摄像头
			$("#camera_config_item_exchange").bind("click",function(){
					var params={open:2};
					if(that.curent_proportion !== ""){
						params.ratio=that.curent_proportion;
					}
					$.ajax({
						type:"post",
						url:that.samewifi?"/v1/mobiles/camera":"/relay/"+that.cid+"/v1/mobiles/camera",
						data:params,
						success:function(data){
							that.frontCamera=!that.frontCamera;
							//如果是前置摄像头禁止开启闪光灯
							if(that.frontCamera){
								//$("#camera_config_item_light").hide();
							}else{
								//$("#camera_config_item_light").show();
							}
							//反转摄像头之后，闪光灯自动关闭了
							if(!that.start){
								$("#camera_operate_button_switch").find("img").addClass("camera_open").removeClass("camera_close");
						    	$("#camera_switch_bar").css("background-color","#fc4847");
						    	that.setCameraSocket();
								that.start=true;
							}
							$("#camera_config_item_light").data("flashlight",1);
							$("#camera_config_item_light").find("img").css("opacity",0.5);
							//反转摄像头之后自动预览
							
							that.closeConfigDiv();

						},
						error:function(){
							$.fn.getProcess("show",{p_text:lang.setContent("camera_5"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
						}
					})
				
			});	
			//图片质量
			$('.single-slider').jRange({
				from:1,//开始于
				to: 5,//结束于
				step: 1,//一次滑动多少
				scale: [lang.setContent("camera_34"),lang.setContent("camera_35"),lang.setContent("camera_36"),lang.setContent("camera_37"),lang.setContent("camera_38")],//分割点
				format: '%s',//格式化格式
				width: 200,//宽度
				showLabels: false,
				showScale: true
			});
		},
		//关闭设置框
		closeConfigDiv:function(){
			$("#camera_config_div").hide();
			$("#camera_config_show_button").find("i").removeClass("uk-icon-close").addClass("uk-icon-cog");

		},
		//设置质量
		setQuality:function(){
			var that=this;
			var qa=$(".single-slider").val();
			$.ajax({
				type:"post",
				url:that.samewifi?"/v1/mobiles/camera/settings/speed":"/relay/"+that.cid+"/v1/mobiles/camera/settings/speed",
				data:{speed:qa},
				success:function(){
				}
			})
		},
		//获取预览图
		startCamera:function(){
			var that=this;
			that.start=true;
			if(!window.WebSocket){
				//不支持websocket时候用长轮循的方式
				that.interval=setInterval(that.getCameraImg,200);
			}else{
				that.cameraSocket.binaryType = "arraybuffer";
				that.cameraSocket.onmessage =function(event){
					if(that.version=="iOS"){
						var byteData=event.data.substring(0,event.data.indexOf("rotate"));
					    var rotate=event.data.substring(event.data.indexOf("rotate")+6);
					    that.setCameraImg(byteData,rotate);
					}else{
						that.setCameraImgByByte(event.data);
					}
					event=null;
				}
			}
		},
		//获取到图片字节流数据，再转换
		setCameraImgByByte:function(result){
			var that=this;
			if(result === "close"){
				if(that.interval != null){
					clearInterval(that.interval);
				}
				//关闭相机之后，旋转摄像头图标隐藏,闪光灯关闭
				$("#camera_config_item_light").data("flashlight",1).css("color","#fff");
				$("#camera_config_item_light").find("img").css("opacity",0.5);
				//$("#camera_exchange_span").hide();
				that.open=false;
				$("#camera_operate_button_switch").find("img").addClass("camera_close").removeClass("camera_open");
				$("#camera_switch_bar").css("background-color","#ccc");
				if(that.cameraSocket != null){
					//关闭之后接收的照片信息不展示
					that.cameraSocket.onmessage =function(event){
					event=null;
				}
			}
				return;
			}
			//闪光灯状态接受
			if(typeof result == "string" && result.indexOf("flashlight") !== -1){
				var flashlight_state=result.substring(10,11);
				if(flashlight_state === "1"){//开启闪光灯
					$("#camera_config_item_light").data("flashlight",0);
					$("#camera_config_item_light").find("img").css("opacity",1);
				}else if(flashlight_state === "0"){//关闭闪光灯
					$("#camera_config_item_light").data("flashlight",1);
					$("#camera_config_item_light").find("img").css("opacity",0.5);
				}
				return;
			}
			
			var bytes = new Uint8Array(result);
		    var data = "";
		    var len = bytes.byteLength;
		    for (var i = 0; i < len; ++i) {
		        data += String.fromCharCode(bytes[i]);
		    }
		    var byteData=data.substring(0,data.indexOf("rotate"));
		    var rotate="";
		    if(that.version=="Android"){
				rotate=data.substring(data.indexOf("rotate")+6,data.indexOf("direction"));
			}else{
				rotate=data.substring(data.indexOf("rotate")+6);
			}
			that.setCameraImg(byteData,rotate);
		},
		//展示图片，调整角度
		setCameraImg:function(byteData,rotate){
			$("#camera_img").attr("src","data:;base64,"+byteData).removeClass("class_0").removeClass("class_270").removeClass("class_180").removeClass("class_90").addClass("class_"+rotate);
			byteData=null;
			rotate=null;
		},
	    //继续预览
	    continueCamera:function(){
			this.openCamera();
	    },
		//停止预览
		stopCamera:function(){
			var that=this;
			that.start=false;
			var params={open:0};
			if(that.curent_proportion !== ""){
				params.ratio=that.curent_proportion;
			}
			$.ajax({
				type:"post",
				url:that.samewifi?"/v1/mobiles/camera":"/relay/"+that.cid+"/v1/mobiles/camera",
				data:params,
				success:function(){
					//停止预览之后后台关闭了摄像头
					if(that.interval != null){
						clearInterval(that.interval);
					}
					//关闭相机之后，旋转摄像头图标隐藏,闪光灯关闭
					$("#camera_config_item_light").data("flashlight",1).css("color","#fff");
					$("#camera_config_item_light").find("img").css("opacity",0.5);
					//$("#camera_exchange_span").hide();
					that.open=false;
					$("#camera_operate_button_switch").find("img").addClass("camera_close").removeClass("camera_open");
					$("#camera_switch_bar").css("background-color","#ccc");
					if(that.cameraSocket != null){
						//关闭之后接收的照片信息不展示
						that.cameraSocket.onmessage =function(event){
						event=null;
						}
					}
				}
			})
		},
		//点击拍照
		photograph:function(){
			var that=this;
			if(!that.open){
				$("#pic_notice_div").show();
				$("#pic_notice_div").delay(3000).hide(0);
				return;
			}
			var location=0;
			if(that.saveDestination == "pc"){//保存到电脑
				location=0;
				$("#download-iframe").attr("src",that.samewifi?"/v1/mobiles/camera/photo?location=0":"/relay/"+that.cid+"/v1/mobiles/camera/photo?location=0");
			}else if(that.saveDestination == "phone"){//保存到手机
				location=1;
				$.ajax({
					type:"get",
					cache:false,
					url:that.samewifi?"/v1/mobiles/camera/photo":"/relay/"+that.cid+"/v1/mobiles/camera/photo",
					data:{location:1},
					success:function(){
						$.fn.getProcess("show",{p_text:lang.setContent("camera_6"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
					},
					error:function(){
						$.fn.getProcess("show",{p_text:lang.setContent("camera_7"),p_icon:""},function(){setTimeout(function(){$.fn.getProcess("hide");},1000)});
					}
				})
			}
		}
	};
	return camera_phone;
})