define(["jquery","zapya","lang","commonHandler","lazeload","lightbox"],function($,zapya,lang,common,lazeload,lightbox){
	images_phone={
	//获取相机照片和图库
		init:function(){
			$("#image-loading-module").show();
			$("#img-permision-notice").hide();
			var that=this;
			$.ajax({
				type: 'get',
				url: zapya.samewifi?"/v1/mobiles/images/camera":"/relay/"+zapya.cid+"/v1/mobiles/images/camera",
				cache:false,
				success: function(data) {
					$(".image_items_container[data-path='"+encodeURIComponent(data.folder)+"']").remove();
			        $(".image_category_item_container[data-path='"+encodeURIComponent(data.folder)+"']").remove();
					that.winCameraFrame(data);
					that.winGalleryImgsFrame(data.photos,"camera",encodeURIComponent(data.folder));
					$("#image-loading-module").hide();
				},
				complete:function(XHR, TS){
					XHR = null;
				},
				error:function(XMLHttpRequest){
					$("#image-loading-module").hide();
					$(".image_items_container").remove();
			        $("#image_category_container").empty();
			        if(XMLHttpRequest.status === 403){
						$("#img-permision-notice").show();
					}	
				}
			});
			//获取图库
			$.ajax({
				type: 'get',
				url: zapya.samewifi?"/v1/mobiles/images/gallery":"/relay/"+zapya.cid+"/v1/mobiles/images/gallery",
				cache:false,
				success: function(data) {
					$(".image_items_container[data-type='gallery']").remove();
			        $(".image_category_item_container[data-type='gallery']").remove();
					that.winGalleryFrame(data);
					$("#image-loading-module").hide();
				},
				error:function(){
					$("#image-loading-module").hide();
					$(".image_items_container[data-type='gallery']").remove();
			        $(".image_category_item_container[data-type='gallery']").remove();
				},
				complete:function(XHR, TS){
					XHR = null;
				}
			});
		},
		privacySure:function(){
			$.ajax({
				type: 'get',
				url: zapya.samewifi?"/v1/mobiles/images/gallery":"/relay/"+zapya.cid+"/v1/mobiles/images/gallery",
				cache:false,
				success:function(){
					if(!$("#img-permision-notice").is(":hidden")){
						$(".refresh-icon").trigger("click");
					}
				},
				error:function(XMLHttpRequest){
					if(XMLHttpRequest.status === 403){
						$(".image_items_container").remove();
			            $("#image_category_container").empty();
						$("#img-permision-notice").show();
					}	
				}
			});
		},
		winCameraFrame:function(data){
			var that=this;
			if(data.photos &&　data.photos.length> 0){
				var front_img_path=data.photos[0].path;
				var front_img_src=zapya.samewifi?"/v1/mobiles/images/thumbs?path="+front_img_path:"/relay/"+zapya.cid+"/v1/mobiles/images/thumbs?path="+front_img_path;
				that.setTab(data.photos,lang.setContent("images_0"),"camera",front_img_src,data.photos.length,data.folder);
				var imgesContainerDom='<div class="image_items_container" data-path="'+encodeURIComponent(data.folder)+'" data-category="camera" style="display:none"></div>';
		        $("#image_module").append(imgesContainerDom);
			}
		},
		winGalleryFrame:function(data){
			var that=this;
			$.each(data,function(idx,gallery){
				var front_img_path=gallery.photopath;
				var front_img_src=zapya.samewifi?"/v1/mobiles/images/thumbs?path="+front_img_path:"/relay/"+zapya.cid+"/v1/mobiles/images/thumbs?path="+front_img_path;
	 			that.setTab([],gallery.name,gallery.name,front_img_src,gallery.num,gallery.path);
	 			var imgesContainerDom='<div class="image_items_container" data-path="'+encodeURIComponent(gallery.path)+'" data-category="'+gallery.name+'" data-type="gallery" style="display:none"></div>';
		        $("#image_module").append(imgesContainerDom);	
			});
		},
		setTab:function(data,title,type,font_page_img_src,count,path){
			var that=this;
			if(data){
				var path=encodeURIComponent(path);
				var image_type="camera";
				if(type !== "camera"){
					image_type="gallery";
				}
				var tabDom='<div class="image_category_item_container uk-width-1-1" data-type="'+image_type+'" data-category="'+type+'" data-path="'+path+'" data-beanopen=false>'+
		    						'<div class="front_page_img">'+
		    							'<img src="'+font_page_img_src+'">'+
		    						'</div>'+
		    						'<div class="image_category_info">'+
		    							'<label class="image_category_label">'+title+'</label>'+
		    							'<label class="image_category_count">('+count+')</label>'+
		    						'</div>'+
		    						'<div class="img_tag_chosen_bt chosen_bt" style="display:none" data-path="'+path+'">'+
		    							'<i class="uk-icon-square-o square-o"></i>'+
		    						'</div>'+
		    					'</div>';
		    	$("#image_category_container").append(tabDom);
		    	that.addHandler();
			}
		},
		//获取图库图片
		getGalleryImg:function(path,type){
			$("#image-loading-module").show();
			var that=this;
			$.ajax({
				type:"get",
				url: zapya.samewifi?"/v1/mobiles/images/gallery/"+path:"/relay/"+zapya.cid+"/v1/mobiles/images/gallery/"+path,
				cache:false,
				success: function(data) {
					$("#image-loading-module").hide();
					that.winGalleryImgsFrame(data,type,path);
					that.lazyloadImg(type,path);
				},
				error:function(){
					$("#image-loading-module").hide();
				},
			})
		},
		//图库图片渲染
		winGalleryImgsFrame:function(data,type,gallerypath){
			var that=this;
		    var imgsArray=[];
	        $.each(data,function(itemIndex,itemInfo){
	            var path=encodeURIComponent(itemInfo.path);
	            var thumbId="";
	            if(itemInfo.thumbId){
	               	thumbId="thumbId="+itemInfo.thumbId+"&";
	            }
	            var bigImg=zapya.samewifi?"/v1/mobiles/images/"+path:"/relay/"+zapya.cid+"/v1/mobiles/images/"+path;
	            var smallImg=zapya.samewifi?"/v1/mobiles/images/thumbs?"+thumbId+"path="+path:"/relay/"+zapya.cid+"/v1/mobiles/images/thumbs?"+thumbId+"path="+path;
	            var imgDom="<div class='imgs_container uk-width-1-3' data-category='"+type+"'>"+
	               	  				"<a href='"+bigImg+"'data-uk-lightbox=\"{group:'"+type+"'}\">"+
	               	  				"<img class='laze_img' src='i/loading.gif' data-original='"+smallImg+"'>"+
	               	  				"<div class='chosen_bt img_chosen_bt' style='display:none' data-path=\""+path+"\">"+
	               	  					'<i class="uk-icon-square-o square-o"></i>'+
		    						'</div>'+
		    						'</a>'+
	               	  			"</div>";
	            imgsArray.push(imgDom);
	        });
	        $(".image_items_container[data-path='"+gallerypath+"']").append(imgsArray.join(""))
			if(type !== "camera"){
				$(".image_items_container[data-path='"+gallerypath+"']").show();
			}
			that.addHandler();
		},
		deleteOrDownloadImg:function(opt){
			var that=this;
			var imgpath="";
			var isGallery=false;
			if($("#image_category_container").is(":hidden")){
				isGallery=false;
			}else{
				isGallery=true;
			}
			$(".check-square").each(function(){
				var path=$(this).parent().data("path");
				imgpath+=path+",";
			})
			if(imgpath == ""){return}
			imgpath=imgpath.substring(0,imgpath.length-1);
			if(opt == "delete"){
				$.fn.getProcess("show",
		    		{ 
			  		    p_text:lang.setContent("common_5"),
			  			p_icon:"",
			  			p_commit:lang.setContent("common_8"),
			  			p_cancel:lang.setContent("common_9"),
			  			p_fn_commit:function(){common.deleteFile(imgpath,that.afterDelet,isGallery);},
			  			p_fn_cancel:function(){$.fn.getProcess("hide");},
					}
				);
			}else{
				common.downloadFiles(imgpath,"",isGallery);
			}
		},
		afterDelet:function(){
			$.fn.getProcess("hide");
			if($("#image_category_container").is(":hidden")){//图库图片
				var $img_tab=$(".check-square").parents(".image_items_container");
				var tab=$img_tab.data("category");
				var tabPath=$img_tab.data("path");
				$(".check-square").parents(".imgs_container ").remove();
				var stillSize=$img_tab.children("div").size();
				if(stillSize === 0){
					$(".image_category_item_container[data-path='"+tabPath+"']").remove();
				}else{
					$(".image_category_item_container[data-path='"+tabPath+"']").find(".image_category_count").html("("+stillSize+")");
					var firstImg=$img_tab.children("div").first().find("img").attr("src");
					if(firstImg === ""){
						firstImg=$img_tab.children("div").first().find("img").attr("data-original");
					}
					$(".image_category_item_container[data-path='"+tabPath+"']").find("img").attr("src",firstImg);
				}
			}else{//图库
				$(".check-square").parents(".image_category_item_container").remove();
			}
			common.isSelectAll();
		},
		addHandler:function(){
			var that=this;
			$("#image_category_container").off("click").on("click",".image_category_item_container",function(){
				if($("#oprate_bar").is(":hidden")){
					var category=$(this).data("category");
					var gallerypath=$(this).data("path");
					if(category === "camera" || $(this).data("beanopen")){
						
					}else{
						//加载图库内容
						var path=$(this).data("path");
						that.getGalleryImg(path,category);
						$(this).data("beanopen",true);
					}
					$("#image_category_container").hide();
					$(".image_items_container[data-path='"+gallerypath+"']").show();
					var title="/"+$(this).find('.image_category_label').html(),
					canBack=true,
					backDom="image";
					$("#image-unit-nav").text(lang.setContent("homepage_1")).show().data("close","no").data("title",title);
					common.setTitleHeader(title,canBack,backDom);
					that.lazyloadImg(category,gallerypath);
					$("#nav_bar_header").data("showmodule","image_tab");
					$(".refresh-icon").hide();
					$(".select-all-button").removeClass("selected");
				}else{
					if($(this).find("i").hasClass("square-o")){
						$(this).find("i").attr("class","uk-icon-check-square check-square")
					}else{
						$(this).find("i").attr("class","uk-icon-square-o square-o")
					}
					common.isSelectAll();
				}
				
			});
			$("#image_module").off("click").on("click",".imgs_container",function(){
				if(! $("#oprate_bar").is(":hidden")){
					if($(this).find("i").hasClass("square-o")){
						$(this).find("i").attr("class","uk-icon-check-square check-square")
					}else{
						$(this).find("i").attr("class","uk-icon-square-o square-o")
					}
					common.isSelectAll();
				}
			})
			$(".laze_img").lazyload();
		},
		//预加载图片
		lazyloadImg:function(tab,gallerypath){
			var window_hight=$(window).height();
			var window_width=$(window).width();
			if($(document).height() == window_hight){
				$(".image_items_container[data-path='"+gallerypath+"'] img").each(function(){
					var $img=$(this);
					if($img.attr("data-original") !== undefined){
						$img.attr("src",$img.attr("data-original")).removeAttr("data-original")
					}
				})
			}else{
				var imgNum=40;
				$(".image_items_container[data-path='"+gallerypath+"'] img").each(function(index){
					var $img=$(this);
					if($img.attr("data-original") !== undefined && index < imgNum){
						$img.attr("src",$img.attr("data-original")).removeAttr("data-original")
					}
				})
			}
		}
	};
	return images_phone;
})