define(["jquery","zapya","lang","commonHandler","videojs"],function($,zapya,lang,common,videojs){
	video_phone={
		videoPlayer:null,
		//获取视频文件夹
        selectFolder:{path:""},
		init:function(){
			var that=this;
			$("#videoFolderContainer").hide();
			$("#video_container").hide();
			$("#video-loading-module").show();
			$("#video-empty-notice").hide();
			$.ajax({
				type:"get",
				url:zapya.samewifi?"/v1/mobiles/videos/folders":"/relay/"+zapya.cid+"/v1/mobiles/videos/folders",
				cache:false,
				success:function(folders){
					$("#video_container").empty();
			        $("#video-loading-module").hide();
					if(folders.length && folders.length > 0){
						that.winFolderFrame(folders);
					}else{
						$("#video-empty-notice").show();
					}
				},
				error:function(XMLHttpRequest){
					$("#videoFolderContainer").empty();
					if(XMLHttpRequest.status === 403){
						$("#video-permision-notice").show();
					}
				},
	            complete:function(XHR, TS){
	            	$("#video-loading-module").hide();
	                XHR = null;
	            }
			});
            that.addHandler();
            that.initPlayer();
		},
		setSelectFolderNull:function(){
			this.selectFolder={path:""};
		},
		getVideosByPath:function(path){
			$("#videoFolderContainer").hide();
			$("#video_container").show().empty();
			$("#video-loading-module").show();
			var that=this;
			$.ajax({
	            type: 'get',
	            url: zapya.samewifi?"/v1/mobiles/videos":"/relay/"+zapya.cid+"/v1/mobiles/videos",
	            data:{folder:decodeURIComponent(path)},
	            cache:false,
	            success: function(data) {
	               that.winFrame(data);
	            },
	            error:function(XMLHttpRequest){
	               $("#video_container").empty();
	               if(XMLHttpRequest.status === 403){
						$("#video-permision-notice").show();
					}
	            },
	            complete:function(XHR, TS){
	            	$("#video-loading-module").hide();
	                 XHR = null;
	            }
	        });
		},
		privacySure:function(){
			$.ajax({
				type: 'get',
				url: zapya.samewifi?"/v1/mobiles/videos/folders":"/relay/"+zapya.cid+"/v1/mobiles/videos/folders",
				cache:false,
                success:function(){
                	if(!$("#video-permision-notice").is(":hidden")){
						$(".refresh-icon").trigger("click");
					}
                },
				error:function(XMLHttpRequest){
					if(XMLHttpRequest.status === 403){
						$("#video_container").empty();
						$("#video-permision-notice").show();
					}	
				}
			});
		},
		winFolderFrame:function(folders){
			var that=this;
			$("#videoFolderContainer").empty();
			var htmls = [];
			$.each(folders,function(index,info){
				var path=encodeURIComponent(info.path);
				var	thumbPath=info.first;
				var front_img_src=zapya.samewifi?"/v1/mobiles/videos/thumbs?path="+thumbPath:"/relay/"+zapya.cid+"/v1/mobiles/videos/thumbs?path="+thumbPath;
				var dom="<div class='video_folder_item_container uk-width-1-1' data-path=\""+path+"\" data-name='"+info.label+"'>"+
								'<div class="front_page_img">'+
	    							'<img src="'+front_img_src+'" onerror=\"javascript:this.src=\'i/movie.png\'\">'+
	    						'</div>'+
	    						'<div class="video_folder_info">'+
	    							'<label class="video_folder_label uk-text-truncate">'+info.label+'</label>'+
	    							'<label class="video_folder_num">('+info.num+')</label>'+
	    						'</div>'+
	    						"<div class='chosen_bt video_chosen_bt' data-path=\""+path+"\">"+
	    							'<i class="uk-icon-square-o square-o"></i>'+
	    						'</div>'+
	    				'</div>';
				htmls.push(dom);
			});
			$("#videoFolderContainer").append(htmls.join(""));
			if(that.selectFolder.path !== ""){
				if($(".video_folder_item_container[data-path='"+that.selectFolder.path+"']").length>0){
					$(".video_folder_item_container[data-path='"+that.selectFolder.path+"']").trigger("click");
				}
			}else{
				$("#videoFolderContainer").show();
			}
		},
		winFrame:function(data){
			var htmls = [];
			$.each(data,function(index,info){
				var path=encodeURIComponent(info.path),
					thumb="";
				if(info.thumbId){
					thumb="thumbId="+data[index].thumbId+"&";
				}
				var front_img_src=zapya.samewifi?"/v1/mobiles/videos/thumbs?"+thumb+"path="+path:"/relay/"+zapya.cid+"/v1/mobiles/videos/thumbs?"+thumb+"path="+path;
				var dom="<div class='video_item_container uk-width-1-1' data-path=\""+path+"\" data-name='"+info.label+"'>"+
								'<div class="front_page_img">'+
	    							'<img src="'+front_img_src+'" onerror=\"javascript:this.src=\'i/movie.png\'\">'+
	    						'</div>'+
	    						'<div class="video_info">'+
	    							'<label class="video_label uk-text-truncate">'+info.label+'</label>'+
	    							'<label class="video_size">'+info.size+'</label>'+
	    						'</div>'+
	    						"<div class='chosen_bt video_chosen_bt' data-path=\""+path+"\">"+
	    							'<i class="uk-icon-square-o square-o"></i>'+
	    						'</div>'+
	    				'</div>';
				htmls.push(dom);
			});
			$("#video_container").append(htmls.join(""));
		},
		addHandler:function(){
			var that=this;
			$("#videoFolderContainer").off("click").on("click",".video_folder_item_container",function(){
				if(! $("#oprate_bar").is(":hidden")){
					if($(this).find("i").hasClass("square-o")){
						$(this).find("i").attr("class","uk-icon-check-square check-square");
					}else{
						$(this).find("i").attr("class","uk-icon-square-o square-o");
					}
					common.isSelectAll();
				}else{//点击获取文件夹视频
					var canBack=true,
					backDom="video",
					title="/"+$(this).data("name");
					common.setTitleHeader(title,canBack,backDom);
					$("#video-unit-nav").text(lang.setContent("homepage_2")).show().data("close","no").data("title",title);
					var folderPath=$(this).data("path");
					that.selectFolder={path:folderPath};
					that.getVideosByPath(folderPath);
				}
			})
			$("#video_container").off("click").on("click",".video_item_container",function(){
				if(! $("#oprate_bar").is(":hidden")){
					if($(this).find("i").hasClass("square-o")){
						$(this).find("i").attr("class","uk-icon-check-square check-square")
					}else{
						$(this).find("i").attr("class","uk-icon-square-o square-o")
					}
					common.isSelectAll();
				}else{//点击播放
					var u = navigator.userAgent
					if(!!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)){//ios浏览器无法播放视频
						return;
					}
					var path=$(this).data("path"),
					    name=$(this).data("name"),
					    video_src=zapya.samewifi?"/v1/mobiles/storages/files?path="+path:"/relay/"+zapya.cid+"/v1/mobiles/storages/files?path="+path;
					$("#edit_icon").hide();
					$(".video-player-title").text(name);
					$("#videoPlayerContainer").css({"top":"80px","left":"0"});
					if(!$("#videoPlayerContainer").is(":hidden")){
					    videojs('my-video').dispose();
					}else{
					    $("#videoPlayerContainer").show();
					}
					$("#my-video").remove();
					var bodyWidth=$("body").width();
					var videoDom='<video id="my-video" class="video-js" preload="auto" controls width="'+bodyWidth+'" height="264">'+
							'<source src="'+video_src+'">'+
							'<p class="vjs-no-js">'+
							  'To view this video please enable JavaScript, and consider upgrading to a web browser that'+
							  '<a href="http://videojs.com/html5-video-support/" target="_blank">supports HTML5 video</a>'+
							'</p>'+
						 '</video>';
					$("#videoPlayerContainer").append(videoDom).show();
					videojs("my-video", {}, function(){
					    var myPlayer = this;
						myPlayer.play();
			        });
				}
			})
		},
		deleteOrDownloadVideo:function(opt){
			var that=this;
			var videopath="";
			$(".check-square").each(function(){
				var path=$(this).parent().data("path");
					videopath+=path+",";
				})
			if(videopath == ""){return;}
			videopath=videopath.substring(0,videopath.length-1);
			if(opt == "delete"){
				$.fn.getProcess("show",
		    		{ 
			  			p_text:lang.setContent("common_6"),
			  			p_icon:"",
			  			p_commit:lang.setContent("common_8"),
			  			p_cancel:lang.setContent("common_9"),
			  			p_fn_commit:function(){
			  				if(video_phone.selectFolder.path === ""){
			  					common.deleteFile(videopath,that.afterDelete,false,true);
			  				}else{
			  					common.deleteFile(videopath,that.afterDelete);
			  				}
			  			},
			  			p_fn_cancel:function(){$.fn.getProcess("hide");},
					}
				);
			}else{
  				if(that.selectFolder.path === ""){
  					common.downloadFiles(videopath,0,0,0,1);
  				}else{
  					common.downloadFiles(videopath,0,0,0,0);
  				}
			}
		},
		afterDelete:function(){
			$.fn.getProcess("hide");
			$(".check-square").parent().parent().remove();
			if(video_phone.selectFolder.path === ""){//视频文件夹
			}else{//视频文件夹里的视频
				var videosLength=$(".video_item_container").length;
				if(videosLength === 0){
					$("#back_icon").trigger("click");
					video_phone.init();
				}else{
					var selectFolder=$(".video_folder_item_container[data-path='"+video_phone.selectFolder.path+"']");
					//$(".check-square").parent().parent().remove();
					selectFolder.find(".video_folder_num").text("("+videosLength+")");
					var firstImg=$(".video_item_container").first().find("img").attr("src");
					selectFolder.find("img").attr("src",firstImg);
				}

			}
			if($(".video_folder_item_container").length === 0){
				$("#video-empty-notice").show();
			}
			common.isSelectAll();
		},
		initPlayer:function(){
			//关闭窗口
			$(".video-player-close").unbind("click").bind("click",function(){
				var myPlayer = videojs("my-video");
        		myPlayer.pause();
        		$("#videoPlayerContainer").css({"top":"-100%","left":"-100%"});
        		$("#edit_icon").show();
			});
		}

	};
	return video_phone;
})
